package com.zcloud.modules.kangzai.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zcloud.common.utils.PageUtils;
import com.zcloud.modules.kangzai.dao.BusReservoirBasicDao;
import com.zcloud.modules.kangzai.entity.BusReservoirBasicEntity;
import com.zcloud.modules.kangzai.service.BusReservoirBasicService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.List;
import java.util.Map;

/**
 * @Author fangjiakai
 * @Desc 水库基本信息表(BusReservoirBasic)表服务实现类
 * @Date 2025-06-09 10:14:59
 */
@Service("busReservoirBasicService")
public class BusReservoirBasicServiceImpl extends ServiceImpl<BusReservoirBasicDao, BusReservoirBasicEntity> implements BusReservoirBasicService {

    @Override
    public BusReservoirBasicEntity queryByFlexibleParams(String paramName, Object paramValue) {
        QueryWrapper<BusReservoirBasicEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(paramName, paramValue); // 根据传入的参数名和参数值动态构建查询条件

        return baseMapper.selectOne(queryWrapper);
    }

    @Override
    public List<BusReservoirBasicEntity> queryListByFlexibleParams(String paramName, Object paramValue) {
        QueryWrapper<BusReservoirBasicEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(paramName, paramValue); // 根据传入的参数名和参数值动态构建查询条件

        return baseMapper.selectList(queryWrapper);
    }

    @Override
    public PageUtils listPage(Map<String, Object> params) {
        Page<Map<String, Object>> page = new Page<>(Integer.parseInt(params.get("curPage").toString()), Integer.parseInt(params.get("limit").toString()));
        params.put("isDelete", 0);
        IPage<BusReservoirBasicEntity> ipage = baseMapper.listPage(page, params);
        return new PageUtils(ipage);
    }


    @Override
    public void delete(String reservoirBasicId, String userId) {
        UpdateWrapper<BusReservoirBasicEntity> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("reservoir_basic_id", reservoirBasicId);

        BusReservoirBasicEntity busReservoirBasic = new BusReservoirBasicEntity();
        busReservoirBasic.setOperator(userId);
        busReservoirBasic.setIsDelete(1);

        this.update(busReservoirBasic, updateWrapper);
    }
}
